]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- bug: getgid check was inversed
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # compiler version
12 %cc_version             %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
13 %cxx_version    %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
14
15 %__rm                   /bin/rm --interactive=never
16
17 # Build system path macros.
18 #
19 %__autoconf             autoconf %{?debug:-Wall}
20 %__automake             automake -a -c -f --foreign
21 %__autopoint            autopoint --force
22
23 %__gettextize { \
24         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
25                 gettextize --copy --force --no-changelog; \
26         else \
27                 gettextize --copy --force --no-changelog --intl; \
28         fi; \
29         if [ ! -f po/Makevars ]; then \
30                 cp -f po/Makevars{.template,}; \
31         fi; \
32 }
33
34 %__glib_gettextize      glib-gettextize --copy --force
35 %__gnome_doc_common     gnome-doc-common --copy
36 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
37 %__gtkdocize            gtkdocize --copy
38 %__intltoolize          intltoolize --copy --force
39 %__libtoolize           libtoolize --copy --force --install
40
41 #       Path to top of build area.
42 %_topdir                %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
43
44 #       The number of cvs changelog entries kept when building package.
45 %_buildchangelogtruncate 20
46
47 %dependencytracking     %{nil}
48
49 #       Relations between package names that cause dependency loops
50 #       with legacy packages that cannot be fixed. Relations are
51 #       specified as
52 #               p>q
53 #       where package p has a Requires: on something that package q Provides:
54 #
55 # XXX   Note: that there cannot be any whitespace within the string "p>q",
56 #       and that both p and q are package names (i.e. no version/release).
57 %_dependency_whiteout   %{nil}
58
59 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
60         && RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
61         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$(($RPM_BUILD_NCPUS * 2))")
62
63 #-----------------------------------------------------------------
64 #
65 # (re)definition of %{rpm*flags} with %filterout_* support
66 # BuildRequires:        awk
67 # BuildRequires:        rpmbuild(macros) >= 1.315
68 #
69 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
70 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
71 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
72 # %rpmcppflags  = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
73 # %rpmldflags   = %optldflags - %filterout_ld
74 #
75 # Regular expressions are supported, but to avoid some character be treated
76 # as regular expression it must be escaped twice.
77
78 %filter_out                                             \
79         for (i = 1; i in I; i++) {      A=0;    \
80                 for (f in F) {                          \
81                         if (I[i] ~ "^" F[f] "$") A=1;   \
82                 };                                                      \
83                 if (!A) printf(I[i] FS);        \
84         }
85
86 %rpmcflags %(awk 'BEGIN {
87         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
88         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
89         %{filter_out}
90 }')
91
92 %rpmcxxflags %(awk 'BEGIN {
93         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
94         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
95         %{filter_out}
96 }')
97
98 %rpmcppflags %(awk 'BEGIN {
99         split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
100         split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
101         %{filter_out}
102 }')
103
104 %rpmldflags %(awk 'BEGIN {
105         split("%{?optldflags}",I);
106         split("%{?filterout_ld}",F)
107         %{filter_out}
108 }')
109
110 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
111 # but, don't use it, better use gcc as linker
112 %ld_rpmldflags %(awk 'BEGIN {
113         split("%{rpmldflags}",F);
114         for (f in F) {
115                 s = F[f];
116                 if (s ~ /^-Wl,/) {
117                         s = substr(s,5);
118                         gsub(/,/," ",s);
119                 };
120                 printf(s FS);
121         };
122 }')
123
124 #-----------------------------------------------------------------
125 %configure2_13 { \
126  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
127  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
128  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
129  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
130  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
131  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
132  CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
133  %{?__cc:CC="%{__cc}" ; export CC ; } \
134  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
135  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
136         --host=%{_target_platform} \
137         --prefix=%{_prefix} \
138         --exec-prefix=%{_exec_prefix} \
139         --bindir=%{_bindir} \
140         --sbindir=%{_sbindir} \
141         --sysconfdir=%{_sysconfdir} \
142         --datadir=%{_datadir} \
143         --includedir=%{_includedir} \
144         --libdir=%{_libdir} \
145         --libexecdir=%{_libexecdir} \
146         --localstatedir=%{_localstatedir} \
147         --sharedstatedir=%{_sharedstatedir} \
148         --mandir=%{_mandir} \
149         --infodir=%{_infodir} \
150         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
151         %{dependencytracking} \
152 }
153
154 %__cmake        /usr/bin/cmake
155 %cmake { \
156 CC="%{__cc}" \
157 CXX="%{__cxx}" \
158 CFLAGS="%{rpmcflags}" \
159 CXXFLAGS="%{rpmcxxflags}" \
160 LDFLAGS="%{rpmldflags}" \
161 %{__cmake} \
162 }
163
164 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
165 %__scons        /usr/bin/scons
166 %scons { \
167 %{__scons} \
168         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
169         CFLAGS="${CFLAGS:-%rpmcflags}" \
170         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
171         FFLAGS="${FFLAGS:-%rpmcflags}" \
172         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
173         %{?__cc:CC="%{__cc}"} \
174         %{?__cxx:CXX="%{__cxx}"} \
175         libsuffix=%{_lib} \
176         prefix=%{_prefix} \
177 }
178
179 # waf. see waf.spec
180 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
181 %__waf  /usr/bin/waf
182 %waf { \
183 CC="%{__cc}" \
184 CXX="%{__cxx}" \
185 CPP="%{__cpp}" \
186 CFLAGS="%{rpmcflags}" \
187 CXXFLAGS="%{rpmcxxflags}" \
188 %{__waf} \
189 }
190
191 #----------------------------------------------------------------
192 #%configure_cache 0
193 %configure_cache_file   %{buildroot}.configure.cache
194
195 %configure {./configure \
196         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
197         CFLAGS="${CFLAGS:-%rpmcflags}" \
198         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
199         FFLAGS="${FFLAGS:-%rpmcflags}" \
200         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
201         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
202         %{?__cc:CC="%{__cc}"} \
203         %{?__cxx:CXX="%{__cxx}"} \
204         --host=%{_target_platform} \
205         --build=%{_target_platform} \
206         --prefix=%{_prefix} \
207         --exec-prefix=%{_exec_prefix} \
208         --bindir=%{_bindir} \
209         --sbindir=%{_sbindir} \
210         --sysconfdir=%{_sysconfdir} \
211         --datadir=%{_datadir} \
212         --includedir=%{_includedir} \
213         --libdir=%{_libdir} \
214         --libexecdir=%{_libexecdir} \
215         --localstatedir=%{_localstatedir} \
216         --sharedstatedir=%{_sharedstatedir} \
217         --mandir=%{_mandir} \
218         --infodir=%{_infodir} \
219         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
220         %{dependencytracking} \
221         %{?configure_cache:--cache-file=%{configure_cache_file}} \
222 }
223
224 # overload to insert debuginfo package
225 %prep \
226 %if 0%{?_enable_debug_packages}\
227 %{debug_package}\
228 %endif\
229 %%prep\
230 %{nil}
231
232 # Location of autoconf macros
233 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
234
235 # Location of omf files
236 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
237
238 # Location of pkgconfig files
239 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
240 # noarch pkgconfig files
241 %_npkgconfigdir /usr/share/pkgconfig
242
243 # Location of desktop files
244 %_desktopdir    /usr/share/applications
245 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
246
247 # Location of pixmaps for applnk/desktop files
248 %_pixmapsdir    /usr/share/pixmaps
249
250 # Location of themable icons for applnk/desktop files
251 %_iconsdir      /usr/share/icons
252
253 # Location of fonts directories
254 %_fontsdir      /usr/share/fonts
255
256 # Location of Gtk and associated libraries documentation
257 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
258
259 # Location of KDE documentation
260 %_kdedocdir     %{_defaultdocdir}/kde/HTML
261
262 # unsermake script
263 %__unsermake /usr/share/unsermake/unsermake
264
265 # Current date
266 %date           %(LC_ALL="C" date +"%a %b %d %Y")
267
268 # Example files, programs, scripts...
269 %_examplesdir   /usr/src/examples
270
271 # Alternative kernel type/version
272 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
273
274 # The directory holding Linux kernel sources
275 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
276
277 # If non-empty "debug" macro defined, add "dbg" suffix to release number
278 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
279
280 # Requires name = version-release
281 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
282
283 %releq_kernel                   %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
284 %releq_kernel_up                %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
285 %releq_kernel_smp()             %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
286 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
287 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
288 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
289
290 # XXX: why epoch 0 is stripped?
291 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
292 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
293
294 %apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
295
296 # kernel version-release handling
297 %__kernel_ver    %{expand:%%global __kernel_ver %( \\
298         Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
299         Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
300         echo ${Z:-ERROR}; \\
301 )}%__kernel_ver
302
303 %__kernel_rel   %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
304 %__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
305 %_kernel_ver    %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
306 %_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
307
308 # `uname -r` to be used in @release field
309 %_kernel_vermagic       %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
310
311 # sgml macros
312 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
313 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
314 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
315 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
316 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
317 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
318 %docbook_sgmlcat_fix() { for l in \
319 '' \
320 '  -- default decl --' \
321 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
322 '  -- hacks for opensp --' \
323 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
324 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
325 '' \
326 ; do echo $l; done >> %1 \
327 }
328
329 # vim - "
330
331 # minimum file size needed for compressed documents.
332 # just smaller files than this get larger when compressed.
333 # some stats:
334 # - 0 byte file compressed was 25 bytes .gz
335 # - 39 byte file was compressed as 57
336 # - with test/test.spec@man 158 byte file was compressed also 158
337 %_min_compress_bytes    159
338
339 #-----------------------------------------------------------------
340 # find and gzip all files in %{_mandir} and %{infodir}
341 #
342 # Requires: xargs, find
343 #
344 #%no_install_post_compress_docs 1
345 %__spec_install_post_compress_docs { \
346 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
347         for i in /usr/share/man /usr/X11R6/man; do \
348                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
349                         echo "Compress man pages: $i"; \
350                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
351                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
352                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
353                                 m=$(readlink $a); \
354                                 rm -f $a; \
355                                 echo .so ${m##*/} > $a; \
356                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
357                         done; \
358                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
359                 fi; \
360         done; \
361         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
362                 echo "Compress info pages: %{_infodir}"; \
363                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
364                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
365                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
366         fi; \
367 }; __spec_install_post_compress_docs } }
368
369 #-----------------------------------------------------------------
370 # Strip executable binaries and shared object files
371 #
372 # Requires: find, awk, strip, cut, xargs
373 #
374 # Special macros which affect this process:
375 #%no_install_post_strip 1               # disable stripping at all
376 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
377 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
378 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
379 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
380 #
381 %__spec_install_post_strip {%{!?debug: \
382 %{!?no_install_post_strip:__spec_install_post_strip() { \
383 if [ -d "$RPM_BUILD_ROOT" ]; then \
384         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
385                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
386                 if [ "$modulelist" ]; then \
387                         modulecount=$(echo "$modulelist" | wc -l); \
388                         printf "Stripping %d kernel modules..." $modulecount; \
389                         echo "$modulelist" | xargs -l512 chmod u+w; \
390                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
391                         echo "DONE"; \
392                 fi; \
393         fi; \
394         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
395         if [ -n "$filelist" ]; then \
396                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
397                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
398                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
399                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
400                 if [ -n "$elfexelist" ]; then \
401                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
402                         chmod u+w $elfexelist; \
403                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
404                         echo "DONE"; \
405                 fi; \
406                 if [ -n "$elfsharedlist" ]; then \
407                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
408                         chmod u+w $elfsharedlist; \
409                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
410                         echo "DONE"; \
411                 fi; \
412                 if [ -n "$archiveslist" ]; then \
413                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
414                         chmod u+w $archiveslist; \
415                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
416                         echo "DONE"; \
417                 fi; \
418         fi; \
419     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
420     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
421     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
422         if [ -n "$filelist_all" ]; then \
423                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
424                 chmod u+w $filelist_all; \
425                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
426                 echo "DONE"; \
427         fi; \
428         if [ -n "$filelist_unneeded" ]; then \
429                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
430                 chmod u+w $filelist_unneeded; \
431                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
432                 echo "DONE"; \
433         fi; \
434         if [ -n "$filelist_debug" ]; then \
435                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
436                 chmod u+w $filelist_debug; \
437                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
438                 echo "DONE"; \
439         fi; \
440 fi; }; __spec_install_post_strip } } }
441
442 #-----------------------------------------------------------------
443 # remove all RPATH from executable binaries and shared object files
444 #
445 # Requires: find, awk, cut, xargs, chrpath, uname
446 #
447 # Special macros which affect this process
448 #%no_install_post_chrpath       1       # disable chrpath at all
449 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
450 #
451 %__spec_install_post_chrpath {%{!?debug: \
452 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
453 if [ -d "$RPM_BUILD_ROOT" ]; then \
454         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
455         if [ -n "$files" ]; then \
456                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
457         fi; \
458         if [ -n "$objs" ]; then \
459                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
460                 echo "$objs" | \
461                 while read file; do \
462                         rpath= ; \
463                         chmod u+w "$file"; \
464                         for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
465                                         case $dir in \
466                                         '$ORIGIN' ) \
467                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
468                                                 else rpath="$rpath:$dir" ; fi ; \
469                                                 continue ; \
470                                                 ;; \
471                                         esac ; \
472                                         newdir=$(readlink -m "$dir"); \
473                                         [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
474                                         case $dir in \
475                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
476                                                 echo "remove-rpath: $dir in $file"; \
477                                                 ;; \
478                                         * ) \
479                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
480                                                 else rpath="$rpath:$dir" ; fi ; \
481                                                 ;; \
482                                         esac ; \
483                         done ; \
484                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
485                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
486                 done; \
487         fi; \
488 fi; }; __spec_install_post_chrpath } } }
489
490 #-----------------------------------------------------------------
491 # Find and gzip all kernel modules
492 #
493 # Requires: find
494 #
495 #%no_install_post_compress_modules      1
496 %__spec_install_post_compress_modules { \
497 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
498         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
499                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
500                 if [ "$q" ]; then \
501                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
502                         echo "$q" | xargs -r %{__gzip} -9nf; \
503                         echo "DONE"; \
504                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
505                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
506                 fi; \
507         fi; \
508 }; __spec_install_post_compress_modules } }
509
510 # Remove common Perl files we don't package
511 %__spec_install_post_perl_clean {\
512 %{!?no_install_post_perl_clean: \
513 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
514 } }
515
516 #-----------------------------------------------------------------
517 # Update GConf2 schemas
518 #
519 # Requires: GConf2
520 #
521 %gconf_schema_install() \
522         umask 022; \
523         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
524         /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
525 %{nil}
526
527 %gconf_schema_uninstall() \
528 if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
529         umask 022; \
530         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
531         /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
532 fi; \
533 %{nil}
534
535 #-----------------------------------------------------------------
536 # Update desktop MIME database
537 # requires: desktop-file-utils
538 %update_desktop_database() {{ \
539         umask 022; \
540         /usr/bin/update-desktop-database -q; \
541 };} \
542 %{nil}
543
544 %update_desktop_database_post %update_desktop_database
545
546 %update_desktop_database_postun() {{ \
547 if [ "$1" = "0" ]; then \
548         %update_desktop_database \
549 fi; \
550 };} \
551 %{nil}
552
553 #-----------------------------------------------------------------
554 # Update shared MIME info database
555 # requires: shared-mime-info
556 #
557 %update_mime_database() {{ \
558         umask 022; \
559         /usr/bin/update-mime-database %{_datadir}/mime; \
560 };} \
561 %{nil}
562
563 #-----------------------------------------------------------------
564 # Update icon cache
565 # requires: gtk+
566 #
567 %update_icon_cache() {{ \
568         umask 022; \
569         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
570 };} \
571 %{nil}
572
573 #-----------------------------------------------------------------
574 # Update scrollkeeper database
575 # requires: scrollkeeper
576 #
577 %scrollkeeper_update_post() \
578         /usr/bin/scrollkeeper-update -q; \
579 %{nil}
580
581 %scrollkeeper_update_postun() \
582 if [ "$1" = "0" ]; then \
583         /usr/bin/scrollkeeper-update -q; \
584 fi; \
585 %{nil}
586
587 #-----------------------------------------------------------------
588 # post %install sequence:
589 # - autodeps exceptions
590 # - compress all man and info pages,
591 # - strip all ELF executables and ELF shared objects if not %debug.
592 # - compress kernel modules if any
593
594 ###################################################################
595 # Requires/Provides automation
596 # exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
597 #
598 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
599 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
600 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
601 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
602 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
603
604 #%_noautocompressdoc    %{nil}
605 #
606 %_missing_doc_files_terminate_build     1%{nil}
607 %_unpackaged_files_terminate_build      %{nil}
608 # (X)emacs support
609 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
610 %_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
611 %_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
612
613 %__php_provides %{nil}
614 %__php_requires %{nil}
615 %__perl_provides %{nil}
616 %__perl_requires %{nil}
617 %__mono_provides %{nil}
618 %__mono_requires %{nil}
619
620 # Perl specific macro definitions.
621 %perl_privlib           %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
622 %perl_archlib           %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
623 %perl_vendorlib         %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
624 %perl_vendorarch        %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
625 %perl_sitelib           %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
626 %perl_sitearch          %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
627
628 # Ruby
629 %__ruby                         /usr/bin/ruby
630 %ruby_archdir           %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
631 %ruby_ridir                     %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
632 %ruby_rubylibdir        %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
633 %ruby_vendorarchdir     %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
634 %ruby_vendorlibdir      %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
635 %ruby_sitearchdir       %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
636 %ruby_sitelibdir        %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
637 %ruby_version           %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
638 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
639 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
640
641 %php_pear_dir           /usr/share/pear
642 %php_data_dir           /usr/share/php
643 %php_extensiondir       %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
644 %php_sysconfdir         %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
645 %php_includedir         %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
646
647 # extract php/zend api versions
648 %php_major_version              %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
649 %php_api_version                %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
650 %php_pdo_api_version    %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
651 %php_debug                              %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
652 %zend_module_api                %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
653 %zend_extension_api             %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
654 %zend_zts                               %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
655
656 # helper macro
657 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
658
659 # macros for public use
660 # for php extensions (php-pecl)
661 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
662 %{__php_api_requires zend_module_api} \
663 %{__php_api_requires -v %php_major_version debug php_debug} \
664 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
665
666 # for zend extensions
667 %requires_zend_extension %{__php_api_requires zend_module_api} \
668 %{__php_api_requires zend_extension_api} \
669 %{__php_api_requires -v %php_major_version debug php_debug} \
670 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
671
672 # for php pdo modules (php-pecl-PDO_*)
673 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
674
675 # for using PHP post scripts. for PHP >= 5.0
676 %php_webserver_restart \
677 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
678 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
679 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
680         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
681         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
682                 %service -q php-fcgi restart \
683         fi \
684 fi \
685 %{nil}
686
687 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
688 %php4_webserver_restart \
689 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
690 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
691 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
692         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
693         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
694                 %service -q php-fcgi restart \
695         fi \
696 fi \
697 %{nil}
698
699 # X.org helper macros
700 %__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
701 %__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
702
703 %xorg_xserver_ansic_abi         %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
704 %xorg_xserver_extension_abi     %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
705 %xorg_xserver_font_abi          %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
706 %xorg_xserver_videodrv_abi      %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
707 %xorg_xserver_xinput_abi        %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
708
709 %requires_xorg_xserver_extension \
710 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
711 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
712 %{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
713 %{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
714 %{nil}
715
716 %requires_xorg_xserver_xinput \
717 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
718 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
719 %{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
720 %{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
721 %{nil}
722
723 %requires_xorg_xserver_font \
724 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
725 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
726 %{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
727 %{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
728 %{nil}
729
730 %requires_xorg_xserver_videodrv \
731 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
732 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
733 %{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
734 %{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
735 %{nil}
736
737 # Python specific macro definitions.
738 # python main version
739 %py_ver                 %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
740
741 # directories
742 %py_prefix              %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
743 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
744 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
745 %py_incdir              /usr/include/python%{py_ver}
746 %py_sitedir             %{py_libdir}/site-packages
747 %py_sitescriptdir %{py_scriptdir}/site-packages
748 %py_dyndir              %{py_libdir}/lib-dynload
749
750 # pure python modules compilation
751 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
752
753 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
754
755 # Software written in Python language require Python with main version
756 %pyrequires_eq() Requires:      %1
757
758 # Hardlink binary identical .pyc and .pyo files
759 # (idea by glen <at> pld-linux <dot> org)
760 %__spec_install_post_py_hardlink {\
761 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
762 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
763         b="${a%.pyc}.pyo"; \
764         if cmp -s "$a" "$b"; then \
765                 ln -f "$a" "$b"; \
766         fi; \
767 done \
768 }; __spec_install_post_py_hardlink } }
769
770 # remove python sources, so that check-files won't complain
771 # (idea by glen <at> pld-linux <dot> org)
772 %py_postclean() \
773 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
774  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
775 done \
776 %{nil}
777
778 # depmod macro
779 %depmod() { \
780 umask 022; \
781 if [ -e /boot/System.map-%1 ]; then \
782         /sbin/depmod -a -F /boot/System.map-%1 %1; \
783 else \
784         if [ -e /boot/System.map ]; then \
785                 /sbin/depmod -a -F /boot/System.map %1; \
786         else \
787                 /sbin/depmod -a %1; \
788         fi \
789 fi; \
790 }
791
792 # XMMS specific macros
793 %xmms_prefix                    %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
794 %xmms_exec_prefix               %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
795 %xmms_version                   %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
796 %xmms_datadir                   %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
797 %xmms_plugindir                 %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
798 %xmms_visualization_plugindir   %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
799 %xmms_input_plugindir           %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
800 %xmms_output_plugindir          %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
801 %xmms_effect_plugindir          %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
802 %xmms_general_plugindir         %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
803
804 %_target_base_arch      %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
805
806 # user/group checking macros
807 #
808 # Usage:
809 #       %userremove myuser
810 #
811 %userremove     /usr/lib/rpm/user_group.sh user del
812 %groupremove    /usr/lib/rpm/user_group.sh group del
813 #
814 # Usage:
815 #       if %usertestrm myuser; then
816 #               /usr/sbin/userdel -r myuser
817 # Note:
818 #       use these macros only if you need to call userdel/groupdel with
819 #       a non-standard option or take an extra action; otherwise use the
820 #       %userremove/%groupremove macros
821 #
822 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
823 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
824 # user group membership management macros
825 #
826 # Usage:
827 #       %addusertogroup myuser agroup
828 #
829 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
830
831 # banner support (useful in {pre,post}{,un} and triggers)
832 #
833 # Usage:
834 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
835 # the banner text, the banner text
836 # the banner text, and following line
837 #EOF
838 # You can use any form of here-document, <<'EOF' <<-EOT will do.
839 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
840 #
841 # -a   - append to the banner
842 # -e   - send to stderr instead of stdout
843 # -n   - no show banner (overrides -t)
844 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
845 #
846 # Tests:
847 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
848 # rpm -E 'date | %banner -e banner' > m; sh -x m
849 #
850 %banner(aent:) ( \
851 RPM_SCRIPTVERBOSITY=5 \
852 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
853 if [ -x /usr/bin/banner.sh ]; then \
854         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
855 else \
856         CMD="cat%{-e: >&2}" \
857 fi \
858 eval $CMD %{?2:%2}%{?3: %3}) \
859 %{nil}
860
861 # useradd/groupadd macros
862 # Author: Elan Ruusamäe <glen@pld-linux.org>
863 #
864 # Usage:
865 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
866 #   [-g initial_group] [-G group[,...]] login
867 #
868 #  -u uid. REQUIRED
869 #  -g gid/group. REQUIRED
870 #  -s defaults to /bin/false
871 #  -d defaults to /usr/share/empty
872 #  -c No default
873 #  -r is accepted but ignored (it's always set)
874 #  -k skeleton dir. defaults to /usr/share/empty
875 # rpm specific flags
876 #  -P package name. defaults to %{name}
877 #
878 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
879 %{!-u:%{error:useradd: Required argument -u missing}} \
880 %{!-g:%{error:useradd: Required argument -g missing}} \
881 %{!?1:%{error:useradd: Required parameter login missing}} \
882 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
883         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
884                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
885                 exit 1 \
886         fi \
887 else \
888         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
889         /usr/sbin/useradd \\\
890                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
891                 -u %{-u*} \\\
892                 -r \\\
893                 -d %{-d*}%{!-d:/usr/share/empty} \\\
894                 -s %{-s*}%{!-s:/bin/false} \\\
895                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
896                 -g %{-g*} \\\
897                 %{-M} \\\
898                 %{-G:-G %{-G*}} \\\
899                 %{expand:%{%{#}}} 1>&2 || exit $? \
900         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
901 fi;
902
903 # Usage:
904 #   %groupadd [-P package] [-g gid] group
905 #
906 # -g gid. REQUIRED
907 #
908 # Sample:
909 #   %groupadd -P %{name}-base -g %{gid} %{name}
910
911 %groupadd(g:P:rfo)      \
912 %{!-g:%{error:groupadd: Required argument -g missing}} \
913 %{!?1:%{error:groupadd: Required parameter group missing}} \
914 if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
915         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
916                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
917                 exit 1 \
918         fi \
919 else \
920         echo "Adding group %{1} GID=%{-g*}." \
921         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
922         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
923 fi;
924
925 # webapp macros
926 # Author: Elan Ruusamäe <glen@pld-linux.org>
927 #
928 # The config is installed/removed inside trigger, this means that you can any
929 # time install apache1/apache/lighttpd package and the configuration file is
930 # updated. if you don't need the config for various reason for specific
931 # webserver, just remove the symlink from config directory using webapp
932 # program. the trigger will not recreate the symlink on upgrades. In other
933 # words the config is linked to webserver config directory on first install of
934 # PACKAGE or WEBSERVER.
935 #
936 # Add package's webserver config to webserver webapps dir.
937 # Usage:
938 #   %webapp_register WEBSERVER WEBAPP
939 #
940 %webapp_register() \
941 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
942 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
943         /usr/sbin/webapp register %1 %2\
944 fi\
945 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
946 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
947         %{expand:%service -q %%1 reload}\
948 fi\
949 %{nil}
950
951 # Remove package's config from webserver webapps dir.
952 # Usage:
953 #   %webapp_register [-f] WEBSERVER WEBAPP
954 %webapp_unregister(f) \
955 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
956 # remove link if either of the packages are gone \
957 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
958         /usr/sbin/webapp unregister %1 %2\
959         %{expand:%service -q %%1 reload}\
960 fi \
961 %{nil}
962
963 # service macro.
964 # Author: Elan Ruusamäe <glen@pld-linux.org>
965 #
966 # calls usual service restart on package %post, but skips the restart if
967 # administrator has disabled automatic service restarts in either global
968 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
969 #
970 # Usage:
971 #   %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
972 #
973 #  -q be silent when service isn't started (for scriplets restaring other package's services)
974 #  -n NOOP mode, do not actually restart service
975 #
976 # Requirements:
977 # BuildRequires:        rpmbuild(macros) >= 1.268
978 # Requires:     rc-scripts
979 # -n option:
980 # BuildRequires:        rpmbuild(macros) >= 1.450
981 %service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
982
983
984 # Java macros. based on jpackage macros.java
985 #
986 # Root directory where all Java VMs/SDK/JREs are installed.
987 %_jvmdir                %{_libdir}/jvm
988
989 # Root directory where all Java VMs/SDK/JREs expose their jars
990 %_jvmjardir             %{_libdir}/jvm-exports
991
992 # Root directory for all Java VM/SDK/JRE's private things.
993 %_jvmprivdir    %{_libdir}/jvm-private
994
995 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
996 %_jvmlibdir             %{_libdir}/jvm
997
998 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
999 %_jvmdatadir    %{_datadir}/jvm
1000
1001 # Root directory for all configurations parts of Java VM/SDK/JRE's
1002 %_jvmsysconfdir %{_sysconfdir}/jvm
1003
1004 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1005 %_jvmcommonlibdir       %{_libdir}/jvm-common
1006
1007 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1008 %_jvmcommondatadir      %{_datadir}/jvm-common
1009
1010 # Root directory for all common configurations parts of Java VM/SDK/JRE's
1011 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
1012
1013 # Directory where arch-specific (JNI) version-independent jars are installed.
1014 %_jnidir                %{_libdir}/java
1015
1016 %java_home              %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
1017
1018 %ant                    JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1019 %jar                    %{java_home}/bin/jar
1020 %java                   %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
1021 %javac                  %{java_home}/bin/javac
1022 %javadoc                %{java_home}/bin/javadoc
1023
1024 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
1025
1026 %jpackage_script() \
1027 install -d $RPM_BUILD_ROOT%{_bindir}\
1028 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1029 #!/bin/sh\
1030 #\
1031 # %{name} script\
1032 # JPackage Project <http://www.jpackage.org/>\
1033 \
1034 # Source functions library\
1035 . %{_javadir}-utils/java-functions\
1036 \
1037 # Source system prefs\
1038 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1039     . %{_sysconfdir}/java/%{name}.conf\
1040 fi\
1041 \
1042 # Source user prefs\
1043 if [ -f $HOME/.%{name}rc ]; then\
1044     . $HOME/.%{name}rc\
1045 fi\
1046 \
1047 # Configuration\
1048 MAIN_CLASS=%1\
1049 BASE_FLAGS=%2\
1050 BASE_OPTIONS=%3\
1051 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1052 \
1053 # Set parameters\
1054 set_jvm\
1055 set_classpath $BASE_JARS\
1056 set_flags $BASE_FLAGS\
1057 set_options $BASE_OPTIONS\
1058 \
1059 # Let's start\
1060 run "$@"\
1061 EOF
1062
1063 # jpackage 1.7
1064 # Directory for maven depmaps
1065 #
1066 %_mavendepmapdir /etc/maven
1067 %_mavendepmapfragdir /etc/maven/fragments
1068
1069 #
1070 # add_to_depmap adds an entry to the depmap. The arguments are:
1071 #
1072 # %1 the original groupid
1073 # %2 the original artifact id
1074 # %3 the version
1075 # %4 the new groupid
1076 # %5 the new artifactid
1077 #
1078
1079 %add_to_maven_depmap() \
1080 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1081 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1082 <dependency>\
1083     <maven>\
1084         <groupId>%1</groupId>\
1085         <artifactId>%2</artifactId>\
1086         <version>%3</version>\
1087     </maven>\
1088     <jpp>\
1089         <groupId>%4</groupId>\
1090         <artifactId>%5</artifactId>\
1091         <version>%3</version>\
1092     </jpp>\
1093 </dependency>\
1094 \
1095 EOF\
1096 %{nil}
1097
1098 #==============================================================================
1099 #
1100 # update_maven_depmap updates the main maven depmap
1101 #
1102 %update_maven_depmap() \
1103 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1104 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1105 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1106 fi\
1107 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1108
1109
1110 # PEAR install macros
1111 # Author: Elan Ruusamäe <glen@pld-linux.org>
1112 #
1113 # Usage:
1114 #       %%pear_package_setup ...
1115 #
1116 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1117 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1118 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1119 # -D     - pass -D to %setup (so the build dir is not removed)
1120 # -c     - register channel from local channel.xml file
1121 #
1122 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1123 # destination hierarchy. you should copy the tree to buildroot after
1124 # patching/reorganizing with %%pear_package_install.
1125 #
1126 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1127 # line endings.
1128 #
1129 # the pear install process output is recorded to install.log, you should put it
1130 # to %%doc for later debug or just for information.
1131 #
1132 # additionally additional-packages.txt is produced if it was detected that the
1133 # package has optional dependencies. the file format is suitable of displaying
1134 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1135 # automatically added for this file.
1136
1137
1138 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1139 %__pear_install_log \
1140 tee install.log \
1141 # make post message of optional packages \
1142 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
1143 if [ -s optional-packages.txt ]; then \
1144         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1145 else \
1146         rm -f optional-packages.txt \
1147 fi \
1148 %{nil}
1149
1150 # command invoking pear cli
1151 %__pear /usr/bin/pear
1152
1153 %pear_install(a:n:zD) \
1154 %__pear \\\
1155         -c %{builddir}/pearrc \\\
1156         -d doc_dir=/docs \\\
1157         -d temp_dir=/tmp \\\
1158         -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1159         -d bin_dir=%{_bindir} \\\
1160         -d data_dir=%{php_pear_dir}/data \\\
1161         -d test_dir=%{php_pear_dir}/tests \\\
1162         install \\\
1163         --packagingroot=%{builddir} \\\
1164         --offline \\\
1165         --nodeps \\\
1166         %{-f:--force} \\\
1167         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1168         %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1169 %{nil}
1170
1171 # The main macro.
1172 # using this macro will append optional-packages.txt to the nocompressdoc list
1173 # as it's displayed to user after package install. and adding additional gzip
1174 # dep is just waste ;)
1175 %pear_package_setup(a:n:zDc:) \
1176 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1177 %define builddir %{_builddir}/%{srcdir} \
1178 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1179 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1180 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1181 %{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1182 %pear_install \
1183 %{-z:cd ..} \
1184 cat %{-z:$_N/}.install.log | %__pear_install_log \
1185 \
1186 # undos sources \
1187 find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1188 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1189 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1190 %{nil}
1191
1192 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1193 # Author: Elan Ruusamäe <glen@pld-linux.org>
1194 %pear_package_install() \
1195 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1196 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1197 # help the developer out a little: \
1198 if [ -f _noautoreq ]; then \
1199         echo "AutoReqdep detected:" \
1200         echo "_noautoreq $(cat _noautoreq)" \
1201 fi \
1202 %{nil}
1203
1204
1205 # Register OpenLDAP schema.
1206 # Author: Elan Ruusamäe <glen@pld-linux.org>
1207 #
1208 # Usage:
1209 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1210 #
1211 #  -d specify dependant schemas, separated by comma
1212 #
1213 %openldap_schema_register(d:) \
1214 for schema in %*; do \
1215         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1216                 %{__sed} -i -e " \
1217                         /^include.*local.schema/{ \
1218                                 iinclude\\t     $schema\
1219                         } \
1220                 " /etc/openldap/slapd.conf \
1221         fi \
1222 done \
1223 # enable dependant schemas \
1224 if [ "%{-d*}" ]; then \
1225         %{__sed} -i -e ' \
1226         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1227                 s/^#// \
1228         }' /etc/openldap/slapd.conf \
1229 fi \
1230 %{nil}
1231
1232 # Unregister OpenLDAP schema.
1233 # Author: Elan Ruusamäe <glen@pld-linux.org>
1234 #
1235 # Usage:
1236 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1237 #
1238 %openldap_schema_unregister() \
1239 for schema in %*; do \
1240         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1241                 %{__sed} -i -e " \
1242                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1243                 # for symmetry it would be nice if we disable enabled schemas in post, \
1244                 # but we really can not do that, it would break something else. \
1245                 " /etc/openldap/slapd.conf \
1246         fi \
1247 done \
1248 %{nil}
1249
1250 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1251
1252
1253 # Build modules for kernels 2.6
1254 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1255 #
1256 # Usage:
1257 #       %build_kernel_modules -m <modules> -C <directory>
1258 #
1259 #  remember that proper Makefile is still required
1260 # Options:
1261 #  -m <modules> (required) -- comma-separated list of modules to save,
1262 #               without .ko extension, may be placed in subdirectory
1263 #  -C <directory> -- change to <directory> before doing anything
1264 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1265 #  -c -- do not execute make clean
1266 #  <additional arguments> -- all additional arguments will be passed to
1267 #               make modules
1268 #
1269 # Additional patching supported via here document. Try:
1270 #       %build_kernel_modules -m module <<'EOF'
1271 #       your patch script here
1272 #       EOF
1273 # Don't use it unless patching depends on config options.
1274
1275 # Developer note: don't touch it unless you know how to handle '\'.
1276 # - \ in script expands to nothing
1277 # - \\\ in script expands to \
1278 # - \\\ inside definition expands to nothing
1279 # - \\\\\\\ inside definition expands to \
1280 # - in last line \ has to touch arguments so arguments passing
1281 #   in new lines (using \) will be supported
1282
1283 %build_kernel_modules(p:P:m:C:c)                                                                        \
1284 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1285                                                                                                                                         \
1286 %define Opts                                                                                                            \\\\\\\
1287 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1288         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1289         CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
1290         %else                                                                                                                   \\\
1291         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1292         %endif                                                                                                                  \\\
1293 %else                                                                                                                           \\\
1294         CC="%{kgcc}"                                                                                                    \\\
1295 %endif                                                                                                                          \
1296 %define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1297                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1298                                                                                                                                         \
1299 %{?-C:cd %{-C*}}                                                                                                        \
1300 compile() {                                                                                                                     \
1301         local L="<" PATCH_SH;                                                                                   \
1302         [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"                   \
1303         set -e -x                                                                                                               \
1304         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1305                                                                                                                                         \
1306 for cfg in ${cfgs:-dist}; do                                        \
1307         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1308                                                                                                                                         \
1309         rm -rf o                                                                                                                \
1310         install -d o/include/linux                                                                              \
1311         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1312         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1313         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1314                                                                                                                                         \
1315         set +x                                                                                                                  \
1316         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1317         set -x                                                                                                                  \
1318                                                                                                                                         \
1319         %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?)  \
1320                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1321                         %{-p*} %{-P*}                                                                                   \\\
1322                         %{MakeOpts}                                                                                             \
1323         %else                                                                                                                   \
1324                 install -d o/include/config                                                                     \
1325                 touch o/include/config/MARKER                                                           \
1326                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1327         %endif                                                                                                                  \
1328                                                                                                                                         \
1329         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1330                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1331                 ${1+"$@"}                                                                                                       \\\
1332                 M=$PWD %{MakeOpts}}                                                                                     \
1333                                                                                                                                         \
1334         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1335                 ${1+"$@"}                                                                                                       \\\
1336                 M=$PWD %{MakeOpts}                                                                                      \
1337                                                                                                                                         \
1338         for MODULE in {%{-m*},}; do                                                                             \
1339                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1340         done                                                                                                                    \
1341 done                                                                                                                            \
1342 %{?-C:cd -}                                                                                                                     \
1343 }                                                                                                                                       \
1344 compile %{*}\
1345 %{nil}
1346
1347
1348 # Install kernel modules built by %build_kernel_modules
1349 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1350 #
1351 # Usage:
1352 #       %install_kernel_modules -m <modules> -d <directory>
1353 #
1354 # Options:
1355 #  -m <modules> (required) -- comma-separated list of modules to install,
1356 #               without .ko extension, may be placed in subdirectory
1357 #  -d <directory> (required) -- in what subdirectory modules should be
1358 #               installed (eg. misc, kernel/drivers/net)
1359 #  -s <suffix> -- suffix to use when installing modules, useful when module
1360 #               with same name exists in kernel already
1361 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1362 #               for defining aliases, only useful with -s
1363
1364 %install_kernel_modules(m:d:s:n:)                                                                       \
1365 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1366 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1367 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1368                                                                                                                                         \
1369 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1370 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1371                                                                                                                                         \
1372 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1373                                                                                                                                         \
1374 for MODULE in {%{-m*},}; do                                                                                     \
1375         [ -n "${MODULE}" ] || continue                                                                  \
1376         for cfg in ${cfgs:-dist}; do                                    \
1377                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1378                 MNAME=${MODULE##*/}                                                                                     \
1379                 install -D ${MODULE}-$cfg.ko                                                            \\\
1380                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1381                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1382                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1383                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1384         done                                                                                                                    \
1385 done                                                                                                                            \
1386 %{nil}
1387
1388 # patchset macros
1389 # Author: Elan Ruusamäe <glen@pld-linux.org>
1390 #
1391 # Usage:
1392 #   %patchset_source -f <seq(1) format> <start> [<end>]
1393 #   %patchset_patch <start> [<end>]
1394 #
1395 # If <end> is omited, it is assumed to be <start>.
1396 #
1397 # For example in preamble:
1398 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1399 # and in %prep:
1400 #  %patchset_patch 33 44
1401
1402 # generate SourceX urls from range START STOP
1403 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1404 # The sources start from 10000
1405 %patchset_source(f:b:) %(
1406         base=%{-b*}%{!-b*:10000};
1407         start=$(expr $base + %1);
1408         end=$(expr $base + %{?2}%{!?2:%{1}});
1409         # we need to call seq twice as it doesn't allow two formats
1410         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1411         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1412         paste %{tmpdir}/__ps{1,2};
1413         rm -f %{tmpdir}/__ps{1,2};
1414 ) \
1415 %{nil}
1416
1417 # apply sources from %patchset_source
1418 # -p specify -pX for %patch line
1419 # -b base offset: defaults to 10000
1420 %patchset_patch(f:p:b:) %(
1421         base=%{-b*}%{!-b*:10000};
1422         start=$(expr $base + %1);
1423         end=$(expr $base + %{?2}%{!?2:%{1}});
1424         echo ": patchset_patch %1%{?2: to %2}";
1425         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1426 ) \
1427 %{nil}
1428
1429 # browser plugins v2
1430 # Author: Elan Ruusamäe <glen@pld-linux.org>
1431 #
1432 # Usage:
1433 #       %browser_plugins_add_browser <name> -p <plugindir>
1434 #
1435 #  <name> (required) -- name of the browser. usually %{name}.
1436 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1437 #  -b -- default blacklists
1438 #  -a <arch> override arch
1439 #
1440 # Example:
1441 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1442
1443 %_browserpluginsconfdir         /etc/browser-plugins
1444 %_browserpluginsdir                     %{_libdir}/browser-plugins
1445 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1446
1447 %browser_plugins_add_browser(p:b:a:) \
1448         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1449         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1450         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1451         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1452         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1453         %{-b:cat >> $blacklist_file %{-b*}} \
1454 %{nil}
1455
1456 # Helper for LUA.
1457 # split string separated by space into quoted list
1458 #
1459 # Author: Elan Ruusamäe <glen@pld-linux.org>
1460 #
1461 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1462 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1463
1464 # adjust /etc/shells by adding and removing shells from there
1465 # Author: Elan Ruusamäe <glen@pld-linux.org>
1466 #
1467 # Usage:
1468 #   %post       -p <lua>
1469 #   %lua_add_etc_shells /bin/sh /bin/pdksh
1470 #
1471 #   %preun      -p <lua>
1472 #   if arg[2] == 0 then
1473 #       %lua_remove_etc_shells /bin/bash /bin/rbash
1474 #   end
1475 #
1476 # Requirements:
1477 # BuildRequires:        rpmbuild(macros) >= 1.462
1478 #
1479
1480 %lua_add_etc_shells() \
1481 t = {}\
1482 f = io.open("/etc/shells", "r")\
1483 if f then\
1484         for l in f:lines() do t[l]=l; end\
1485         f:close()\
1486 end\
1487 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1488         if not t[s] then\
1489                 print("Adding "..s.." to /etc/shells")\
1490                 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1491         end\
1492 end\
1493 %{nil}
1494
1495 %lua_remove_etc_shells() \
1496 t = {}\
1497 f = io.open("/etc/shells", "r")\
1498 if f then\
1499         for l in f:lines() do t[l]=l; end\
1500         f:close()\
1501 end\
1502 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1503         print("Removing "..l.." from /etc/shells")\
1504         t[l] = nil\
1505 end\
1506 s=""\
1507 for _, l in pairs(t) do\
1508         s=s..l.."\\n"\
1509 end\
1510 io.open("/etc/shells", "w"):write(s)\
1511 %{nil}
1512
1513 # Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1514 #
1515 # Author: Elan Ruusamäe <glen@pld-linux.org>
1516 #
1517 # Usage:
1518 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1519 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1520 #
1521 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1522 #
1523 # Requirements:
1524 # BuildRequires:        rpmbuild(macros) >= 1.429
1525 #
1526 %add_etc_shells(p) %{-p:<lua>}\
1527 %{expand:%%lua_add_etc_shells %*}\
1528 %{nil}
1529
1530 %remove_etc_shells(p) %{-p:<lua>}\
1531 %{-p:if arg[2] == 0 then}\
1532 %{expand:%%lua_remove_etc_shells %*}\
1533 %{-p:end} \
1534 %{nil}
1535
1536 # Check syntax for Python files
1537 #
1538 # Author: Elan Ruusamäe <glen@pld-linux.org>
1539 # Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1540 #
1541 # Usage:
1542 #   %py_lint src
1543 #
1544 # Requirements:
1545 # BuildRequires:        python
1546 # BuildRequires:        rpmbuild(macros) >= 1.469
1547
1548 %py_lint() \
1549 __py_lint() { \
1550 find "$@" -type f -name '*.py' | python -c ' \
1551 import sys \
1552 import compiler \
1553 \
1554 err = 0\
1555 for f in sys.stdin: \
1556         fd = open(f.strip()) \
1557         c = fd.read() \
1558         fd.close() \
1559         try: \
1560                 compiler.parse(c) \
1561         except SyntaxError, e: \
1562                 print "py_lint: %s: %s" % (f.strip(), e) \
1563                 err = err + 1\
1564 \
1565 if err: \
1566         print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1567         sys.exit(1) \
1568 else: \
1569         print >> sys.stderr,  "py_lint: Found no syntax errors." \
1570 ' \
1571 }; __py_lint %* \
1572 %{nil}
1573
1574 # vim:ts=4 sw=4 noet syn=spec
This page took 0.325522 seconds and 3 git commands to generate.